#!/bin/bash
home="/home/pi/"
gcode=$home"Achsencheck_XY.gcode"
xmin=0
xmax=239
ymin=0
ymax=200
z=50
centerx=`bc -l <<< "scale=3; $xmax/2"`
centery=`bc -l <<< "scale=3; $ymax/2"`
incr=20
xstep=`bc -l <<< "scale=3; $xmax/$incr"`
ystep=`bc -l <<< "scale=3; $ymax/$incr"`
minspeed=1
maxspeed=20000
#read speeds
q=0
while [ $q -eq 0 ]
do
	read -p "min. Vorschubgeschwindigkeit -> " response
	if [[ "$response" != *[[:digit:]]* || "$response" -lt "$minspeed" || "$repponse" -gt "$maxspeed" ]]; then
		q=0
		echo "Wert ungültig ($minspeed-$maxspeed)!"
	else
		q=1
		minspeed=$response
	fi
done
q=0
while [ $q -eq 0 ]
do
	read -p "max. Vorschubgeschwindigkeit -> " response
	if [[ "$response" != *[[:digit:]]* || "$response" -le "$minspeed" || "$response" -gt "$maxspeed" ]]; then
		q=0
		echo "Wert ungültig - muss größer als 0 oder min. Vorschubgeschw. (max. $maxspeed) sein!"
	else
		q=1
		maxspeed=$response
	fi
done
#loops
q=0
while [ $q -eq 0 ]
do
	read -p "Anzahl Wiederholungen (0=keine) -> " response
	if [[ "$response" != *[[:digit:]]* || "$response" -lt 0 ]]; then
		q=0
		echo "Wert ungültig (min. 0)!"
	else
		q=1
		loop=$[$response+1]
	fi
done
#
if [ $xmax -gt $ymax ]; then
	speedstep=`bc -l <<< "scale=3; ($maxspeed-$minspeed)/($xmax/$xstep)"`
else
	speedstep=`bc -l <<< "scale=3; ($maxspeed-$minspeed)/($ymax/$ystep)"`
fi
i=0
q=0
xpos=0
ypos=0
#start
echo "G28" >$gcode
echo "G1 F$maxspeed Z$z" >>$gcode
echo "G1 X$xmin Y$ymin" >>$gcode
#start loop
while [ $loop -gt -1 ];
do
	#
	while [ $i -lt $loop ];
	do
		#x-axis
		speed=$minspeed
		while [ x"$(echo "$ypos < $ymax" | bc -l)" = x1 ];
		do
			echo "G1 F$speed X$xmax" >>$gcode
			ypos=`bc -l <<< "scale=3; $ypos+$ystep"`
			echo "G1 Y$ypos" >>$gcode
			speed=`bc -l <<< "scale=3; $speed+$speedstep"`
			echo "G1 F$speed X$xmin" >>$gcode
			ypos=`bc -l <<< "scale=3; $ypos+$ystep"`
			echo "G1 Y$ypos" >>$gcode
			speed=`bc -l <<< "scale=3; $speed+$speedstep"`
		done
		echo "G1 F$maxspeed X$xmax" >>$gcode
		#y-axis
		speed=$minspeed
		xpos=$xmax
		while [ x"$(echo "$xpos > $xmin" | bc -l)" = x1 ];
		do
			echo "G1 F$speed Y$ymin" >>$gcode
			xpos=`bc -l <<< "scale=3; $xpos-$xstep"`
			echo "G1 X$xpos" >>$gcode
			speed=`bc -l <<< "scale=3; $speed+$speedstep"`
			echo "G1 F$speed Y$ymax" >>$gcode
			xpos=`bc -l <<< "scale=3; $xpos-$xstep"`
			echo "G1 X$xpos" >>$gcode
			speed=`bc -l <<< "scale=3; $speed+$speedstep"`
		done
		echo "G1 F$maxspeed Y$ymin" >>$gcode
		i=$[$i+1]
		if [ $i -lt $loop ]; then
			echo "M117 Wiederholung $i" >>$gcode
		fi
		xpos=0
		ypos=0
		speed=$minspeed
	done
	loop=$[$loop-1]
done
echo "G1 F$maxspeed X$centerx Y$centery" >>$gcode
echo "M117 Achsencheck beendet!" >>$gcode
exit
